From 415e90b7f5e6f76ad1fe87edc0f24b7202677d8b Mon Sep 17 00:00:00 2001
From: Baochen qiang <bqiang@codeaurora.org>
Date: Fri, 17 Jul 2020 20:00:19 +0800
Subject: [PATCH 165/173] ath11k: add support to get peer id for QCA6490

For QCA6490, the layout of hal rx mpdu info is different compared
with QCA6390/QCA6290, so need to handle this target differently when
getting peer id.

Tested-on: QCA6490 hw1.1 PCI WLAN.HSP.1.1-00687-QCAHSPSWPL_V1_SILICONZ-1

Signed-off-by: Baochen qiang <bqiang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/hal_rx.c | 42 +++++++++++++++++++++++++++-----
 1 file changed, 36 insertions(+), 6 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/hal_rx.c b/drivers/net/wireless/ath/ath11k/hal_rx.c
index c6c02bf..4cd66b9 100644
--- a/drivers/net/wireless/ath/ath11k/hal_rx.c
+++ b/drivers/net/wireless/ath/ath11k/hal_rx.c
@@ -868,6 +868,41 @@ static void ath11k_hal_reo_hw_setup_qca6490(struct ath11k_base *ab, u32 ring_has
 			ring_hash_map);
 }
 
+static u16 ath11k_hal_rx_mpdu_info_get_peerid(struct ath11k_base *ab, u8* tlv_data){
+	u16 peer_id = 0;
+
+	switch(ab->hw_rev){
+		case ATH11K_HW_IPQ8074:
+		case ATH11K_HW_QCA6290:
+		case ATH11K_HW_QCA6390:
+			{
+				struct hal_rx_mpdu_info *mpdu_info =
+					(struct hal_rx_mpdu_info*)tlv_data;
+#ifdef HAL_RX_MPDU_INFO_INFO0_PEERID
+#undef HAL_RX_MPDU_INFO_INFO0_PEERID
+#endif
+#define HAL_RX_MPDU_INFO_INFO0_PEERID GENMASK(31, 16)
+				peer_id = FIELD_GET(HAL_RX_MPDU_INFO_INFO0_PEERID,
+						__le32_to_cpu(mpdu_info->info0));
+			}
+			break;
+		case ATH11K_HW_QCA6490:
+			{
+				struct hal_rx_mpdu_info_qca6490 *mpdu_info =
+					(struct hal_rx_mpdu_info_qca6490*)tlv_data;
+#ifdef HAL_RX_MPDU_INFO_INFO0_PEERID
+#undef HAL_RX_MPDU_INFO_INFO0_PEERID
+#endif
+#define HAL_RX_MPDU_INFO_INFO0_PEERID GENMASK(15, 0)
+				peer_id = FIELD_GET(HAL_RX_MPDU_INFO_INFO0_PEERID,
+						__le32_to_cpu(mpdu_info->info0));
+			}
+			break;
+		default:
+			ath11k_err(ab, "Unsupported hw rev: 0x%x\n", ab->hw_rev);
+	}
+	return peer_id;
+}
 static enum hal_rx_mon_status
 ath11k_hal_rx_parse_mon_status_tlv(struct ath11k_base *ab,
 				   struct hal_rx_mon_ppdu_info *ppdu_info,
@@ -1158,12 +1193,7 @@ static void ath11k_hal_reo_hw_setup_qca6490(struct ath11k_base *ab, u32 ring_has
 		break;
 	}
 	case HAL_RX_MPDU_START: {
-		struct hal_rx_mpdu_info *mpdu_info =
-			(struct hal_rx_mpdu_info *)tlv_data;
-		u16 peer_id;
-
-		peer_id = FIELD_GET(HAL_RX_MPDU_INFO_INFO0_PEERID,
-				    __le32_to_cpu(mpdu_info->info0));
+		u16 peer_id = ath11k_hal_rx_mpdu_info_get_peerid(ab, tlv_data);
 		if (peer_id)
 			ppdu_info->peer_id = peer_id;
 		break;
-- 
1.9.1

